﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication23
{
    public partial class Form1 : Form
    {

        private Steema.TeeChart.Styles.Line line1;
        private const int majorcount = 4;
        private double[] majors = new double[majorcount];   
        private double[] minors = new double[Math.Abs(2 * majorcount - 2)];
        public Form1()
        {
            InitializeComponent();

            // major ticks = labels 
            majors[0] = 0.1;
            majors[1] = 0.2;
            majors[2] = 0.5;
            majors[3] = 1.0;

            // two minors between each major tick 
            minors[0] = 0.12;
            minors[1] = 0.17;

            minors[2] = 0.30;
            minors[3] = 0.38;

            minors[4] = 0.55;
            minors[5] = 0.7;
            InitializeChart();
        }
        private void InitializeChart()
        {
            line1 = new Steema.TeeChart.Styles.Line(tChart1.Chart);
            tChart1.Aspect.View3D = false;
            checkBox1.Checked = true;
            for (int t = 0; t < 100; t++)
            {
                line1.Add(t, 2.0E-3 * (5 * t - 50) * (2 * t - 10) + 5.0);
            }
            tChart1.BeforeDrawAxes +=new Steema.TeeChart.PaintChartEventHandler(tChart1_BeforeDrawAxes);
        }
        private int GetDecade(double Value)
        {
            double absval = Math.Abs(Value);
            int res = 0;
            if (absval >= 1)
            {
                while (absval >= 1.0)
                {
                    absval /= 10.0;
                    res++;
                }
            }
            else
            {
                while (absval < 1.0)
                {
                    absval *= 10.0;
                    res--;
                }
            }
            return res;
        } 

        private void GenerateLogLabels(Steema.TeeChart.Drawing.Graphics3D g, Steema.TeeChart.Axis ax, double[] majorlabels, double[] minorticks, int start, int end)
        {
            ax.Labels.Items.Clear();
            int mindecade = GetDecade(ax.Minimum);
            int maxdecade = GetDecade(ax.Maximum);
            double currval;
            int tickypos;

            start -= ax.MinorTicks.Length;
            end += ax.MinorTicks.Length;

            g.Pen.Style = ax.MinorGrid.Style;
            g.Pen.Color = ax.MinorGrid.Color;

            for (int i = mindecade; i <= maxdecade; i++)
            {
                for (int j = 0; j < majorlabels.Length; j++)
                {
                    currval = majorlabels[j] * Math.Pow(10, i);
                    if (currval >= ax.Minimum && currval <= ax.Maximum)
                        ax.Labels.Items.Add(currval);
                }
                for (int k = 0; k < minorticks.Length; k++)
                {
                    currval = minorticks[k] * Math.Pow(10, i);
                    if (currval >= ax.Minimum && currval <= ax.Maximum)
                    {
                        tickypos = ax.CalcPosValue(currval);
                        if (ax.Horizontal)
                            g.Line(tickypos, start, tickypos, end);
                        else
                            g.Line(start, tickypos, end, tickypos);
                    }
                }
            }
        }

        private void checkBox1_CheckedChanged(object sender, System.EventArgs e)
        {
            tChart1.Axes.Left.Logarithmic = checkBox1.Checked;
        }

        private void checkBox2_CheckedChanged(object sender, System.EventArgs e)
        {
            tChart1.Invalidate();
        }

        private void tChart1_BeforeDrawAxes(object sender, Steema.TeeChart.Drawing.Graphics3D g)
        {
            if (checkBox1.Checked && checkBox2.Checked)
            {
                GenerateLogLabels(g, line1.GetVertAxis, majors, minors,
                        line1.GetHorizAxis.IStartPos, line1.GetHorizAxis.IEndPos);
                tChart1.Invalidate();
            }
            else line1.GetVertAxis.Labels.Items.Clear();
        }

       
     
       //Steema.TeeChart.Styles.Points points1;
       // Steema.TeeChart.Tools.DrawLine drawline1;
        //private void InitializeChart()
        //{
         //   tChart1.Aspect.View3D = false;
         //   tChart1.Legend.Visible = false;

         //   points1 = new Steema.TeeChart.Styles.Points(tChart1.Chart);
         //   points1.FillSampleValues();
         //   tChart1.Dock = DockStyle.Fill;
         //   drawline1 = new Steema.TeeChart.Tools.DrawLine(tChart1.Chart);
         //   //  drawline1.NewLine += new Steema.TeeChart.Tools.DrawLineEventHandler(drawline1_NewLine);
         //   Steema.TeeChart.Tools.DrawLineItem I = new Steema.TeeChart.Tools.DrawLineItem(drawline1);
         //   /* set the "Y" line positions (start and end position) */
         //   //double tmp = points1.YValues.Range / 5.0;
         //   //   tChart1.Draw();
         //   // tChart1.Axes.Left.PositionUnits= Steema.TeeChart.PositionUnits.Pixels;
         //   //I.StartPos = new Steema.TeeChart.Drawing.PointDouble(20, 30);//tChart1.Axes.Bottom.IStartPos,tChart1.Axes.Left.IStartPos);
         //   //I.EndPos = new Steema.TeeChart.Drawing.PointDouble(25, 45);//tChart1.Axes.Bottom.IEndPos, tChart1.Axes.Left.IEndPos);
         //   //drawline1.EnableDraw = false;
         ////   tChart1.Draw();

         //  // Steema.TeeChart.Tools.DrawLineItem I = new Steema.TeeChart.Tools.DrawLineItem(drawline1);
         //   /* set the "Y" line positions (start and end position) */
         //   double tmp = points1.YValues.Range / 5.0;
         //   I.StartPos = new Steema.TeeChart.Drawing.PointDouble(tChart1.Axes.Bottom.Minimum, tChart1.Axes.Left.Maximum);
         //   I.EndPos = new Steema.TeeChart.Drawing.PointDouble(tChart1.Axes.Bottom.Maximum, tChart1.Axes.Left.Minimum);
         //   drawline1.EnableDraw = false;
         //   tChart1.MouseMove += new MouseEventHandler(tChart1_MouseMove);
           // tChart1.AfterDraw += new Steema.TeeChart.PaintChartEventHandler(tChart1_AfterDraw);
           //tChart1.AfterDraw += new Steema.TeeChart.PaintChartEventHandler(tChart1_AfterDraw);
        // }

        //void tChart1_AfterDraw(object sender, Steema.TeeChart.Drawing.Graphics3D g)
        //{
        //    Point p0 = new Point(tChart1.Axes.Bottom.IStartPos,tChart1.Axes.Left.IStartPos);
        //    Point p1 = new Point(tChart1.Axes.Bottom.IEndPos,tChart1.Axes.Left.IEndPos);
        //    g.Line(p0, p1);
        //}

        //void tChart1_MouseMove(object sender, MouseEventArgs e)
        //{
        //    this.Text = "X:" + e.X.ToString() + "Y:" + e.Y.ToString();


        //}
        

        //void tChart1_ClickAxis(object sender, MouseEventArgs e)
        //{
        //    if (sender == tChart1.Axes.Bottom)
        //    {
        //        this.Text = "XBottom Píxels value: " + e.X.ToString() + " YBottom Píxes value: " + e.Y.ToString();
        //    }
        //    else if (sender == tChart1.Axes.Left)
        //    {
        //        this.Text = "XLeftPíxels value: " + e.X.ToString() + " YLeftPíxels value: " + e.Y.ToString();
        //    }
        //}



    }

   }